"use strict";
var reassemble_1 = require("reassemble");
var shallowEqual = require("fbjs/lib/shallowEqual");
var runInFrame_1 = require("../utils/runInFrame");
var pick_1 = require("../utils/pick");
var reducer_1 = require("../reducer");
exports.withTransitionState = function (reduce) { return reassemble_1.combine(reassemble_1.isolate(reassemble_1.withProps(function (props) { return ({ actionProps: pick_1.default.apply(void 0, [props].concat(reducer_1.actionPropKeys)) }); }), reassemble_1.withState("transitionState", "setTransitionState", function (_a) {
    var actionProps = _a.actionProps;
    return pick_1.default(reduce(reducer_1.StateID.EntryPoint, { kind: reducer_1.ActionID.Init, props: actionProps }).state, "style", "className", "inTransition");
}), reassemble_1.withHandlers(function (initialProps) {
    var stateID = reduce(reducer_1.StateID.EntryPoint, { kind: reducer_1.ActionID.Init, props: initialProps }).state.id;
    var cancelPending = null;
    var cancelPendingIfExistent = function () {
        if (cancelPending) {
            cancelPending();
            cancelPending = null;
        }
    };
    return {
        cancelPendingIfExistent: function () { return cancelPendingIfExistent; },
        dispatch: function (_a) {
            var actionProps = _a.actionProps, onTransitionComplete = _a.onTransitionComplete, setTransitionState = _a.setTransitionState, transitionState = _a.transitionState;
            var run = function (actionID) {
                var result = reduce(stateID, { kind: actionID, props: actionProps });
                if (!result) {
                    return;
                }
                if (result.completed && onTransitionComplete) {
                    onTransitionComplete();
                }
                var state = result.state, pending = result.pending;
                stateID = state.id;
                cancelPendingIfExistent();
                var callback;
                if (pending) {
                    callback = function () {
                        cancelPending = runInFrame_1.default(1, function () { return run(pending); });
                    };
                }
                if (!shallowEqual(transitionState.style, result.state.style) ||
                    transitionState.className !== result.state.className ||
                    transitionState.inTransition !== result.state.inTransition) {
                    setTransitionState(pick_1.default(state, "style", "className", "inTransition"), callback);
                }
                else if (callback) {
                    callback();
                }
            };
            return run;
        },
    };
}), reassemble_1.withHandlers({
    onTransitionBegin: function (_a) {
        var dispatch = _a.dispatch;
        return function () { return dispatch(reducer_1.ActionID.TransitionStart); };
    },
    onTransitionComplete: function (_a) {
        var dispatch = _a.dispatch;
        return function () { return dispatch(reducer_1.ActionID.TransitionComplete); };
    },
}), reassemble_1.onDidMount(function (_a) {
    var dispatch = _a.dispatch;
    dispatch(reducer_1.ActionID.Mount);
}), reassemble_1.onWillUnmount(function (_a) {
    var cancelPendingIfExistent = _a.cancelPendingIfExistent;
    cancelPendingIfExistent();
}), reassemble_1.onWillReceiveProps(function (_a, _b) {
    var prevActive = _a.active;
    var nextActive = _b.active, dispatch = _b.dispatch;
    if (prevActive === nextActive) {
        return;
    }
    dispatch(reducer_1.ActionID.TransitionTrigger);
}), reassemble_1.integrate("transitionState", "onTransitionBegin", "onTransitionComplete"))); };

//# sourceMappingURL=withTransitionState.js.map
