import { combine, withState, withHandlers, withProps, onDidMount, onWillUnmount, onWillReceiveProps, isolate, integrate, } from "reassemble";
import * as shallowEqual from "fbjs/lib/shallowEqual";
import runInFrame from "../utils/runInFrame";
import pick from "../utils/pick";
import { ActionID, StateID, actionPropKeys } from "../reducer";
export var withTransitionState = function (reduce) { return combine(isolate(withProps(function (props) { return ({ actionProps: pick.apply(void 0, [props].concat(actionPropKeys)) }); }), withState("transitionState", "setTransitionState", function (_a) {
    var actionProps = _a.actionProps;
    return pick(reduce(StateID.EntryPoint, { kind: ActionID.Init, props: actionProps }).state, "style", "className", "inTransition");
}), withHandlers(function (initialProps) {
    var stateID = reduce(StateID.EntryPoint, { kind: ActionID.Init, props: initialProps }).state.id;
    var cancelPending = null;
    var cancelPendingIfExistent = function () {
        if (cancelPending) {
            cancelPending();
            cancelPending = null;
        }
    };
    return {
        cancelPendingIfExistent: function () { return cancelPendingIfExistent; },
        dispatch: function (_a) {
            var actionProps = _a.actionProps, onTransitionComplete = _a.onTransitionComplete, setTransitionState = _a.setTransitionState, transitionState = _a.transitionState;
            var run = function (actionID) {
                var result = reduce(stateID, { kind: actionID, props: actionProps });
                if (!result) {
                    return;
                }
                if (result.completed && onTransitionComplete) {
                    onTransitionComplete();
                }
                var state = result.state, pending = result.pending;
                stateID = state.id;
                cancelPendingIfExistent();
                var callback;
                if (pending) {
                    callback = function () {
                        cancelPending = runInFrame(1, function () { return run(pending); });
                    };
                }
                if (!shallowEqual(transitionState.style, result.state.style) ||
                    transitionState.className !== result.state.className ||
                    transitionState.inTransition !== result.state.inTransition) {
                    setTransitionState(pick(state, "style", "className", "inTransition"), callback);
                }
                else if (callback) {
                    callback();
                }
            };
            return run;
        },
    };
}), withHandlers({
    onTransitionBegin: function (_a) {
        var dispatch = _a.dispatch;
        return function () { return dispatch(ActionID.TransitionStart); };
    },
    onTransitionComplete: function (_a) {
        var dispatch = _a.dispatch;
        return function () { return dispatch(ActionID.TransitionComplete); };
    },
}), onDidMount(function (_a) {
    var dispatch = _a.dispatch;
    dispatch(ActionID.Mount);
}), onWillUnmount(function (_a) {
    var cancelPendingIfExistent = _a.cancelPendingIfExistent;
    cancelPendingIfExistent();
}), onWillReceiveProps(function (_a, _b) {
    var prevActive = _a.active;
    var nextActive = _b.active, dispatch = _b.dispatch;
    if (prevActive === nextActive) {
        return;
    }
    dispatch(ActionID.TransitionTrigger);
}), integrate("transitionState", "onTransitionBegin", "onTransitionComplete"))); };

//# sourceMappingURL=withTransitionState.js.map
