var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import convertToCSSPrefix from "./utils/convertToCSSPrefix";
var TransitionConfig = (function () {
    function TransitionConfig(value, params) {
        this.value = value;
        this.params = params;
    }
    return TransitionConfig;
}());
export function transit(value, duration, timing, delay) {
    return new TransitionConfig(value, {
        duration: duration,
        timing: timing || "ease",
        delay: delay !== undefined ? delay : 0,
    });
}
export function resolveTransit(style, extraDelay) {
    if (extraDelay === void 0) { extraDelay = 0; }
    var transition = "";
    var processedStyle = __assign({}, style);
    for (var property in style) {
        var val = style[property];
        if (typeof val === "object") {
            var _a = val, value = _a.value, _b = _a.params, duration = _b.duration, timing = _b.timing, delay = _b.delay;
            if (transition !== "") {
                transition += ", ";
            }
            transition += convertToCSSPrefix(property) + " " + duration + "ms " + timing + " " + (delay + extraDelay) + "ms";
            processedStyle[property] = value;
        }
    }
    if (transition) {
        processedStyle.transition = transition;
    }
    return processedStyle;
}

//# sourceMappingURL=transit.js.map
